FilterLeafReader.FilterPostingsEnum (Lucene 10.5.1 core API)
Description: declaration: package: org.apache.lucene.index, class: FilterLeafReader, class: FilterPostingsEnum

Package org.apache.lucene.index

# Class FilterLeafReader.FilterPostingsEnum

java.lang.Object
org.apache.lucene.search.DocIdSetIterator
org.apache.lucene.index.PostingsEnum
org.apache.lucene.index.FilterLeafReader.FilterPostingsEnum

All Implemented Interfaces:
  `Unwrappable<PostingsEnum>`

Enclosing class:
  `FilterLeafReader`

public abstract static class FilterLeafReader.FilterPostingsEnum extends PostingsEnum implements Unwrappable<PostingsEnum>
Base class for filtering `PostingsEnum` implementations.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected final PostingsEnum`
  `in`
  The underlying PostingsEnum instance.

  ### Fields inherited from class org.apache.lucene.index.PostingsEnum

  `ALL, FREQS, NONE, OFFSETS, PAYLOADS, POSITIONS`

  ### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

  `NO_MORE_DOCS`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `FilterPostingsEnum(PostingsEnum in)`
  Create a new FilterPostingsEnum

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `advance(int target)`
  Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
  `long`
  `cost()`
  Returns the estimated cost of this `DocIdSetIterator`.
  `int`
  `docID()`
  Returns the following: `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
  `int`
  `endOffset()`
  Returns end offset for the current position, or -1 if offsets were not indexed.
  `int`
  `freq()`
  Returns term frequency in the current document, or 1 if the field was indexed with `IndexOptions.DOCS`.
  `BytesRef`
  `getPayload()`
  Returns the payload at this position, or null if no payload was indexed.
  `int`
  `nextDoc()`
  Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
  `int`
  `nextPosition()`
  Returns the next position, or -1 if positions were not indexed.
  `int`
  `startOffset()`
  Returns start offset for the current position, or -1 if offsets were not indexed.
  `PostingsEnum`
  `unwrap()`
  Unwraps this instance

  ### Methods inherited from class org.apache.lucene.index.PostingsEnum

  `featureRequested, nextPostings`

  ### Methods inherited from class org.apache.lucene.search.DocIdSetIterator

  `all, docIDRunEnd, empty, intoBitSet, range, slowAdvance`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### in

    protected final PostingsEnum in
    The underlying PostingsEnum instance.

- ## Constructor Details

  - ### FilterPostingsEnum

    protected FilterPostingsEnum(PostingsEnum in)
    Create a new FilterPostingsEnum
    Parameters:
      `in` - the underlying PostingsEnum instance.

- ## Method Details

  - ### docID

    public int docID()
    Description copied from class: `DocIdSetIterator`
    Returns the following:
    - `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
    - `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
    - Otherwise it should return the doc ID it is currently on.
    Specified by:
      `docID` in class `DocIdSetIterator`

  - ### freq

    public int freq() throws IOException
    Description copied from class: `PostingsEnum`
    Returns term frequency in the current document, or 1 if the field was indexed with `IndexOptions.DOCS`. Do not call this before `DocIdSetIterator.nextDoc()` is first called, nor after `DocIdSetIterator.nextDoc()` returns `DocIdSetIterator.NO_MORE_DOCS`.

    NOTE: if the `PostingsEnum` was obtain with `PostingsEnum.NONE`, the result of this method is undefined.

    Specified by:
      `freq` in class `PostingsEnum`
    Throws:
      `IOException`

  - ### nextDoc

    public int nextDoc() throws IOException
    Description copied from class: `DocIdSetIterator`
    Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
    NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
    Specified by:
      `nextDoc` in class `DocIdSetIterator`
    Throws:
      `IOException`

  - ### advance

    public int advance(int target) throws IOException
    Description copied from class: `DocIdSetIterator`
    Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `DocIdSetIterator.NO_MORE_DOCS` if target is greater than the highest document number in the set.

    The behavior of this method is undefined when called with `target ≤ current` , or after the iterator has exhausted. Both cases may result in unpredicted behavior.

    When `target > current` it behaves as if written:

         int advance(int target) {
           int doc;
           while ((doc = nextDoc()) < target) {
           }
           return doc;
         }

    Some implementations are considerably more efficient than that.

    NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

    Specified by:
      `advance` in class `DocIdSetIterator`
    Throws:
      `IOException`

  - ### nextPosition

    public int nextPosition() throws IOException
    Description copied from class: `PostingsEnum`
    Returns the next position, or -1 if positions were not indexed. Calling this more than `PostingsEnum.freq()` times is undefined.
    Specified by:
      `nextPosition` in class `PostingsEnum`
    Throws:
      `IOException`

  - ### startOffset

    public int startOffset() throws IOException
    Description copied from class: `PostingsEnum`
    Returns start offset for the current position, or -1 if offsets were not indexed.
    Specified by:
      `startOffset` in class `PostingsEnum`
    Throws:
      `IOException`

  - ### endOffset

    public int endOffset() throws IOException
    Description copied from class: `PostingsEnum`
    Returns end offset for the current position, or -1 if offsets were not indexed.
    Specified by:
      `endOffset` in class `PostingsEnum`
    Throws:
      `IOException`

  - ### getPayload

    public BytesRef getPayload() throws IOException
    Description copied from class: `PostingsEnum`
    Returns the payload at this position, or null if no payload was indexed. You should not modify anything (neither members of the returned BytesRef nor bytes in the byte[]).
    Specified by:
      `getPayload` in class `PostingsEnum`
    Throws:
      `IOException`

  - ### cost

    public long cost()
    Description copied from class: `DocIdSetIterator`
    Returns the estimated cost of this `DocIdSetIterator`.

    This is generally an upper bound of the number of documents this iterator might match, but may be a rough heuristic, hardcoded value, or otherwise completely inaccurate.

    Specified by:
      `cost` in class `DocIdSetIterator`

  - ### unwrap

    public PostingsEnum unwrap()
    Description copied from interface: `Unwrappable`
    Unwraps this instance
    Specified by:
      `unwrap` in interface `Unwrappable<PostingsEnum>`